<template>
  <b-row v-if="dataList.length > 0">
    <news-horizontal
      v-for="(news, index) in dataList"
      :key="index + generateId()"
      :moduleContent="news"
      :moduleName="moduleName"
      :pageName="pageName"
      :listProducts="dataList"
      :nbConfigImg="nbImages"
      :tnInZText="tnInZText"
      :tnInZImg="tnInZImg"
      :tnLg="tnLg"
      :reverse="reverse"
      :large="large"
    ></news-horizontal>
  </b-row>
</template>
<script>
import jsonConfigBuilder from "@/config-data/config-products.json";
import NewsHorizontal from "@/components/AppPopupNews/news.vue";
const URL_API = process.env.VUE_APP_URL_DISTANT_API;
const URL_DATAS_ACTIV = URL_API + "api/popups/list/activ/";
const URL_CATEGORIES_LIST_FROM = URL_API + "api/categories-from-name/";
export default {
  props: ["moduleName", "reverse", "tnLg", "tnInZText", "tnInZImg", "large", "nbConfigImg"],
  components: {
    "news-horizontal": NewsHorizontal
  },
  created: function() {
    this.getCurrentPage();
    this.getCat();
  },
  data() {
    return {
      nbImages: 0,

      dataList: [],
      contentRaw: [],
      pageName: null,

      catName: null,
      scat1Name: null,
      scat2Name: null,
      scat3Name: null,
      tableCat: [],
      itemsAriane: [],
      jsonConfigBuilder
    };
  },
  methods: {
    generateId() {
      return Math.floor(Math.random() * 10000);
    },
    fetchDatas(moduleName) {
      let payLoad = {
        categorie: this.tableCat[0],
        scat1: this.tableCat[1],
        scat2: this.tableCat[2],
        scat3: this.tableCat[3]
      };

      this.$axios
        .post(URL_DATAS_ACTIV + moduleName, payLoad)
        .then(response => {
          // console.log(response.data.data);
          this.contentRaw = response.data.data;
          this.structureData();
        })
        .catch(error => {
          console.log("error", error);
        });
    },

    structureData() {
      this.dataList = this.contentRaw
        .filter(mod => {
          let arraySimplePrices = [];
          mod.data = JSON.parse(mod.data);
          mod.dataprix = JSON.parse(mod.dataprix);
          // structuration prix simple pour meilleur lisibilité coté front
          mod.dataprix.simplePrice.forEach((prix, key) => {
            arraySimplePrices["prix" + parseInt(key + 1)] = parseFloat(prix["prix" + parseInt(key + 1)]);
          });
          mod.dataprix.structured = arraySimplePrices;
          return mod;
        })

        // classement par ordre
        .sort(function(a, b) {
          return parseFloat(a.ordre) - parseFloat(b.ordre);
        });
    },

    getCurrentPage() {
      this.pageName = this.$router.currentRoute.name;
    },

    getCat() {
      // console.log("ALLPARAMS", this.$route.params);
      this.tableCat.push(this.$route.params.categorie);
      this.tableCat.push(this.$route.params.scat1);
      this.tableCat.push(this.$route.params.scat2);
      this.tableCat.push(this.$route.params.scat3);
      this.constructAriane();
      this.fetchDatas(this.moduleName);
    },

    constructAriane() {
      let configCat = this.jsonConfigBuilder.filter(mod => {
        return mod.module == this.moduleName;
      });
      this.nbImages = configCat[0].medias.images;

      let nodeCat = [];
      this.$axios
        .get(URL_CATEGORIES_LIST_FROM + configCat[0].confCatSlug)
        .then(response => {
          // construction de la liste des données du module (news)
          nodeCat = JSON.parse(response.data.data[0].data);
          nodeCat = JSON.parse(nodeCat.categories);

          // let arianePath = "";
          let arianePath = "/" + this.$router.currentRoute.name;

          this.tableCat.forEach((lvl, idx) => {
            arianePath += "/" + this.tableCat[idx];
            if (lvl !== "" && lvl !== undefined) {
              let elm = {
                text: lvl,
                href: arianePath
              };

              for (let i = 0; i < nodeCat.length; i++) {
                if (nodeCat[i].slug == lvl) {
                  elm.text = nodeCat[i].title;
                  if (nodeCat[i].children.length > 0) {
                    nodeCat = nodeCat[i].children;
                  }
                  break;
                }
              }
              this.itemsAriane.push(elm);
            }
          });
        })
        .catch(error => {
          console.log("error = ", error);
        });
    }
  }
};
</script>
